package ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp

import ru.landgrafhomyak.db.serdha0.api.misc.Reducer
import ru.landgrafhomyak.db.serdha0.api.runtime.InputRow
import ru.landgrafhomyak.db.serdha0.api.runtime.OutputRow

@Suppress("PropertyName", "MemberVisibilityCanBePrivate")
class COUNT private constructor(context: Reducer.Constructor.Scope<COUNT>) : Reducer.Action<COUNT> {
	val C_Counter = context.outputColumn("counter", context.types.U64, 0u)

	override fun calculate(acc: OutputRow<COUNT>, row: OutputRow<COUNT>, newAcc: InputRow<COUNT>) {
		newAcc[this.C_Counter] = acc[this.C_Counter] + 1u
	}

	companion object Constructor : Reducer.Constructor<COUNT> {
		override fun createReducer(context: Reducer.Constructor.Scope<COUNT>) =
			COUNT(context)
	}
}