package ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0

import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.STRING
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.U64
import ru.landgrafhomyak.db.serdha0.api.table.TableConstructor

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
class T_Users private constructor(context: TableConstructor.Scope<T_Users>) {
	val C_RowId = context.rowIdColumn
	val C_TgUid = context.column("telegram::user_id", context.types.U64)
	val C_DisplayName = context.column("display_name", context.types.STRING)

	val U_TgUid = context.uniqueIndex("telegram::user_id", true, this.C_TgUid)

	companion object Constructor : TableConstructor<T_Users> {
		override fun createTable(context: TableConstructor.Scope<T_Users>) =
			T_Users(context)
	}
}