package ru.landgrafhomyak.bgtu.db0.storage.serdha.queries

import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.M_V0
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_User2Queue
import ru.landgrafhomyak.db.serdha0.api.module.Module
import ru.landgrafhomyak.db.serdha0.api.queries.DeleteQuery
import ru.landgrafhomyak.db.serdha0.api.table.Table

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
internal class D_RemoveUserFromQueue private constructor(context: DeleteQuery.SingleRow.Constructor.Scope<D_RemoveUserFromQueue, T_User2Queue>) {
	val P_RowId = context.rowToRemove

	private class _Constructor(
		override val targetTable: Table<T_User2Queue, *>
	) : DeleteQuery.SingleRow.Constructor<D_RemoveUserFromQueue, T_User2Queue> {
		override fun createDeleteSingleRowWithReturning(context: DeleteQuery.SingleRow.Constructor.Scope<D_RemoveUserFromQueue, T_User2Queue>) =
			D_RemoveUserFromQueue(context)
	}

	companion object Constructor {
		operator fun invoke(module: Module<M_V0>) : DeleteQuery.SingleRow.Constructor<D_RemoveUserFromQueue, T_User2Queue> = _Constructor(module.uExt.user2queue)
	}
}