import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.defineAllMultiplatformTargets

buildscript {
	repositories {
		mavenCentral()
		maven("https://maven.landgrafhomyak.ru/")
	}

	dependencies {
		classpath("ru.landgrafhomyak.kotlin:kotlin-mpp-gradle-build-helper:v0.2k2.0.20")
	}
}

plugins {
	kotlin("multiplatform") version "2.0.20"
}

val serdhaVersion: String by project

repositories {
	mavenCentral()
	maven("https://maven.landgrafhomyak.ru/")
}

kotlin {
	jvmToolchain(21)
	defineAllMultiplatformTargets()

	sourceSets {
		commonMain {
			dependencies {
				implementation("ru.landgrafhomyak.db.serdha:serdha-0-api:$serdhaVersion")
				implementation(project(":storage-serdha:schema"))
				compileOnly(project(":storage-api"))
			}
		}
	}
}